function[X_new, P_new] = fcn_RGTLS_InverseIteration(A, B, P_old, X_old, errCov, lambda)
%#codegen
%
[~, n] = size(A);
q = n+1;
%
Z = [A, B]; %augumented data matrix
G = 1 / (lambda + (Z * P_old * Z'));
L = (P_old * Z') * G;% gain vector, Kalman gain        
P_new = ((eye(q) - L * Z) * P_old) / lambda; % covariance matrix 
%constrained generalized inverse Power Method [Feng2006]-----------
v = [X_old; -1];
p = P_new * (errCov * v);
v = -p / p(q);
X_new = v(1:n);
%--------------------------------------------------------------------------
 end
